SystemOrganization addCategory: #'Glamour-Tests-Morphic'!

TestCase subclass: #GLMMorphicTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

GLMMorphicTest subclass: #GLMAccumulatorMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 00:09'!
testActiveEntity
	| browser tabs |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	browser entity: $d.
	browser entity: $e.
	window := browser openOn: $d.
	tabs := window submorphs last.
	browser entity: $c.
	tabs selectedPageIndex: 1.
	tabs update: #selectedIndex.
	self assert: browser activeEntity = $d.! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/31/2011 18:24'!
testCloseTab
	| browser tabs |
	browser := GLMAccumulator new.
	browser show: [:a | 
		a title: [:x | x asString ].
		a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	browser entity: $c.
	tabs := window submorphs last.
	self assert: browser panes size = 2.
	self assert: tabs pageMorphs size = 2.
	tabs removePageIndex: 1.
	self assert: tabs pageMorphs size = 1.
	self assert: browser panes size = 1.! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:45'!
testCreation
	| browser |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	self assert: window submorphs last class = LazyTabGroupMorph.! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: 'tg 1/18/2010 09:07'!
testListInside
	| browser tabs firstTreeMorph |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	self assert: (tabs pageAt: 1) submorphs first submorphs first class = LazyMorphTreeMorph.
	firstTreeMorph := (tabs pageAt: 1) submorphs first submorphs first.
	self assert: ((firstTreeMorph roots collect: #complexContents) collect: #item) = ($a to: $d) asArray! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:48'!
testPaneCreation
	| browser tabs |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	self assert: tabs pages size = 1.
	browser entity: $c.
	self assert: tabs pages size = 2! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: 'lr 6/4/2010 14:36'!
testSelectedTab
	| browser tabs |
	browser := GLMAccumulator new.
	browser show: [:a | 
		a title: [:x | x asString ].
		a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	self assert: tabs selectedPageIndex = 1.
	browser entity: $c.
	self assert: tabs selectedPageIndex = 2.
	browser entity: $d.
	self assert: tabs selectedPageIndex = 1! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 01:31'!
testTabTitle
	| browser tabs firstTabLabel |
	browser := GLMAccumulator new.
	browser show: [:a | 
		a title: [:x | x asString ].
		a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	firstTabLabel := tabs tabSelectorMorph submorphs first submorphs first.
	self assert: (firstTabLabel isKindOf: PanelMorph).
	self assert: firstTabLabel submorphs size = 2.
	self assert: firstTabLabel submorphs first contents = 'd'.
	self assert: (firstTabLabel submorphs last isKindOf: MultistateButtonMorph).! !

GLMMorphicTest subclass: #GLMCompositePresentationMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'tg 1/14/2010 23:00'!
testAccordion
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a accordionArrangement.
		a list title: 'List'.
		a text title: 'Text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = PanelMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = ExpanderMorph.
	self assert: compositeMorph submorphs last class = ExpanderMorph.! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'tg 1/14/2010 23:00'!
testAccordionExpanded
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a accordionArrangement.
		a list title: 'List'.
		a text title: 'Text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph submorphs first expanded.
	self assert: compositeMorph submorphs last expanded not.! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:45'!
testAccordionWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a accordionArrangement.
		a title: 'title'.
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph contentMorph class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs first submorphs size = 2.
	self assert: compositeMorph contentMorph submorphs first submorphs first class = ExpanderMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:45'!
testFinder
	| finder |
	finder := GLMFinder new.
	finder show: [:a |
		a title: 'something'.
		a stackedArrangement.
		a list.
		a text].
	self assert: finder presentations size = 2.
	self assert: (finder presentations arrangement isKindOf: GLMStackedVerticallyArrangement).
	window := finder openOn: (1 to: 42).
	self assert: (window submorphs last submorphs first submorphs first submorphs first isKindOf: LazyTabGroupMorph) ! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:45'!
testOneStackedVerticallyWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a stackedVerticallyArrangement.
		a title: 'title'.
		a list ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph contentMorph class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs size = 1.
	self assert: compositeMorph contentMorph submorphs first class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs first submorphs size = 1.
	self assert: compositeMorph contentMorph submorphs first submorphs first class = LazyTabGroupMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/30/2011 16:42'!
testOneTabWithActions
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a list
			act: #inspect entitled: 'Inspect' ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = PanelMorph.
	self assert: compositeMorph submorphs size = 2! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:45'!
testStackedVertically
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a stackedVerticallyArrangement.
		a list title: 'list'.
		a text title: 'text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = PanelMorph.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = LazyTabGroupMorph.! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:45'!
testStackedVerticallyWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a stackedVerticallyArrangement.
		a title: 'title'.
		a list title: 'list'.
		a text title: 'text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph contentMorph class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs size = 1.
	self assert: compositeMorph contentMorph submorphs first class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs first submorphs size = 2.
	self assert: compositeMorph contentMorph submorphs first submorphs first class = LazyTabGroupMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:49'!
testTabs
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph pages size = 2.! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 00:01'!
testTabsLastActivePresentation
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	compositeMorph selectedPageIndex: 2.
	self assert: browser panes first lastActivePresentation notNil.
	self assert: (browser panes first lastActivePresentation isKindOf: GLMTextPresentation)! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/30/2011 16:31'!
testTabsWithActions
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a list
			act: #inspect entitled: 'Inspect'.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph toolbarMorph submorphs notEmpty.
	compositeMorph selectedPageIndex: 2.
	self assert: compositeMorph toolbarMorph submorphs isEmpty.
	compositeMorph selectedPageIndex: 1.
	self assert: compositeMorph toolbarMorph submorphs notEmpty! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 21:49'!
testTabsWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a title: 'title'.
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = PanelMorph.
	self assert: compositeMorph submorphs first submorphs size = 1.
	self assert: compositeMorph submorphs first submorphs first class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs first submorphs first pages size = 2.! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/4/2011 14:20'!
testTabsWithTitleIconWithoutTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a titleIcon: GLMUIThemeExtraIcons glamorousBrowse.
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = PanelMorph.
	self assert: compositeMorph submorphs first submorphs size = 1.
	self assert: compositeMorph submorphs first submorphs first class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs first submorphs first pages size = 2.! !

GLMMorphicTest subclass: #GLMDynamicMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMDynamicMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/4/2011 18:19'!
testSurroundingPanel
	| browser dynamicContainerMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | a dynamic presentation: [:some :object | some text ]].
	window := browser openOn: 4.

	dynamicContainerMorph := window submorphs last submorphs first submorphs first.
	self assert: (dynamicContainerMorph isKindOf: PanelMorph).
	self assert: (dynamicContainerMorph submorphs first isKindOf: PluggableTextMorph)! !

!GLMDynamicMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/4/2011 18:37'!
testUpdate
	| browser dynamicContainerMorph presentationObject |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a dynamic presentation: [:some :object | 
			some custom: presentationObject ]].
	presentationObject := GLMTextPresentation new.
	window := browser openOn: 42.
	dynamicContainerMorph := window submorphs last submorphs first submorphs first.
	self assert: (dynamicContainerMorph isKindOf: PanelMorph).
	self assert: (dynamicContainerMorph submorphs first isKindOf: PluggableTextMorph).
	presentationObject := GLMListPresentation new.
	browser update.
	dynamicContainerMorph := window submorphs last submorphs first submorphs first.
	self assert: (dynamicContainerMorph isKindOf: PanelMorph).
	self assert: (dynamicContainerMorph submorphs first submorphs first isKindOf: LazyMorphTreeMorph)! !

GLMMorphicTest subclass: #GLMExpanderMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMExpanderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/5/2011 16:58'!
testCreation
	| browser |
	browser := GLMExpander new.
	browser show: [ :a | a text ].
	window := browser openOn: #(a b c).
	self assert: window submorphs last class = LazyMorphTreeMorph.
	self assert: window submorphs last roots size = 3.
	self assert: window submorphs last roots first complexContents class = GLMExpanderLabelNodeModel.
	self assert: window submorphs last roots first complexContents contents size = 1.
	self assert: window submorphs last roots first complexContents contents first class = GLMExpanderContentsNodeModel ! !

GLMMorphicTest subclass: #GLMFinderMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 4/12/2011 12:53'!
testClose
	| finder |
	finder := GLMFinder new.
	window := finder openOn: 123.
	self assert: window owner notNil.
	finder close.
	self assert: window owner isNil! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/26/2011 11:15'!
testCreationVariableSize
	window := GLMFinder new variableSizePanes; openOn: 123.
	self assert: window submorphs last class = GeneralScrollPane! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/26/2011 12:46'!
testDefaultFixedSizePanes
	| finder |
	finder := GLMFinder new.
	window := finder openOn: 40.

	self assert: window submorphs last submorphs first submorphs first width = (window submorphs last width).
	(finder panes first port: #selection) value: 42.

	self assert: window submorphs last submorphs first submorphs size = 3.
	self assert: window submorphs last submorphs first submorphs first extent = window submorphs last submorphs first submorphs last extent.
	self assert: window submorphs last submorphs first submorphs first width <= (window submorphs last width / 2)! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/16/2011 13:01'!
testFixedSize
	window := GLMFinder new openOn: 123.
	self assert: window submorphs last class = GLMPaneScroller.! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:39'!
testMultiplePresentationsValidation
	| browser |
	browser := GLMFinder new.
	browser list.
	browser text.
	window := browser openOn: ($a to: $d).
	(browser panes first port: #selection) value: $z.
	self assert: (browser panes first port: #selection) value = $z! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:39'!
testNoSelection
	| browser treeMorph treeNodeMorph  |
	browser := GLMFinder new.
	browser tree noSelection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: browser panes size = 1! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/26/2011 12:48'!
testOneFixedSizePane
	| finder |
	finder := GLMFinder new fixedSizePanes: 1.
	window := finder openOn: 40.

	self assert: window submorphs last submorphs first submorphs first width = (window submorphs last width).
	(finder panes first port: #selection) value: 42.

	self assert: window submorphs last submorphs last submorphs size = 3.
	self assert: window submorphs last submorphs last submorphs first extent = window submorphs last submorphs last submorphs last extent.
	self assert: window submorphs last submorphs last submorphs first width = (window submorphs last width).
! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/26/2011 11:15'!
testRemovingVariableSizePanes
	| finder |
	finder := GLMFinder new variableSizePanes.
	window := finder openOn: 40.
	self assert: window submorphs last scrollTarget submorphs size = 2.
	(finder panes first port: #selection) value: 41.
	self assert: window submorphs last scrollTarget submorphs size = 4.
	(finder panes first port: #selection) value: 42.
	self assert: window submorphs last scrollTarget submorphs size = 4.
	(finder panes second port: #selection) value: 43.
	self assert: window submorphs last scrollTarget submorphs size = 6.
	(finder panes first port: #selection) value: 44.
	self assert: window submorphs last scrollTarget submorphs size = 4.
! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/26/2011 11:15'!
testRemovingVariableSizePanesWhenChangingEntity
	| finder |
	finder := GLMFinder new variableSizePanes.
	window := finder openOn: #a.
	self assert: window submorphs last scrollTarget submorphs size = 2.
	finder entity: #b.
	self assert: window submorphs last scrollTarget submorphs size = 2! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:37'!
testSpawnFinder
	| browser |
	browser := GLMFinder new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [window submorphs last class] equals: GLMPaneScroller.
! !

GLMMorphicTest subclass: #GLMListMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMListMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:42'!
testListDoubleClick

	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a list ].
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value = $a.! !

!GLMListMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:42'!
testListDoubleClickWithMultipleSelection

	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value asSet = ($a to: $d) asSet.! !

!GLMListMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:41'!
testMultipleSelectionWithChange
	| browser firstTreeMorph secondTreeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | a list beMultiple; display: [:x | (x - 2 to: x) ]].
	window := browser openOn: 4.

	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := firstTreeMorph scroller submorphs first.
	lastTreeNodeMorph := firstTreeMorph scroller submorphs last.
	self send: firstTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: firstTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (firstTreeMorph model selection selectedNodePathList collect: [:each | each first item]) =  #(2 3 4) asOrderedCollection.
	
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := secondTreeMorph scroller submorphs first.
	lastTreeNodeMorph := secondTreeMorph scroller submorphs second.
	self send: secondTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: secondTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (secondTreeMorph model selection selectedNodePathList collect: [:each | each first item]) =  #(40 41) asOrderedCollection.! !

!GLMListMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:41'!
testMultipleSelectionWithChangeFromModel
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | a list beMultiple; display: [:x | (x - 2 to: x) ]].
	window := browser openOn: 4.

	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (firstTreeMorph model roots collect: #item) = #(2 3 4).
	((browser paneNamed: #one) port: #selection) value: #(2 3).
	self assert: ((browser paneNamed: #one) port: #selection) value asOrderedCollection = #(2 3) asOrderedCollection.
	
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (secondTreeMorph model roots collect: #item) = #(40 41 42).
	((browser paneNamed: #one) port: #selection) value: #(40 41).
	self assert: ((browser paneNamed: #one) port: #selection) value asOrderedCollection = #(40 41) asOrderedCollection.

	self assert: firstTreeMorph ~= secondTreeMorph! !

!GLMListMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:41'!
testTwoPanesMultipleSelectionWithChange
	| browser treeMorphOne treeNodeMorph treeMorphTwo |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser transmit to: #one; andShow: [:a |
		a list display: [:x | 1 to: x ]].
	browser transmit to: #two; from: #one; andShow: [:a |
		a list beMultiple; display: [:x | (x * 10) to: (x * 10 + 4) ] ].
	browser transmit to: #three; from: #two; andShow: [:a | a text ].
	window := browser openOn: 4.

	"we select 2 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs second.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.

	"we select all in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.

	self assert: ((browser paneNamed: #two) port: #selection) value = #(20 21) asOrderedCollection.
	
	"we select 4 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs last.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.

	"we select the first two in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	self assert: (treeMorphTwo model roots collect: #item) = #(40 41 42 43 44).
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.

	self assert: ((browser paneNamed: #two) port: #selection) value = #(40 41) asOrderedCollection ! !

!GLMListMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:42'!
testUpdateFromModel
	| browser  treeMorphOne1 treeMorphTwo1 treeMorphOne2 treeMorphTwo2 |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a | a list display: [:x | (x - 3 to: x) ]].
	browser transmit to: #two; from: #one; andShow: [:a |
		a list display: [:x | x * 10 to: (x * 10 + 2)]].
	window := browser openOn: 4.

	treeMorphOne1 := window submorphs last submorphs second submorphs first submorphs first.
	self assert: (treeMorphOne1 model roots collect: #item) = #(1 2 3 4).
	((browser paneNamed: #one) port: #selection) value: 2.	
	treeMorphTwo1 := window submorphs last submorphs last submorphs first submorphs first.
	self assert: (treeMorphTwo1 model roots collect: #item) = #(20 21 22).

	browser entity: 8.

	treeMorphOne2 := window submorphs last submorphs second submorphs first submorphs first.
	self assert: (treeMorphOne2 model roots collect: #item) = #(5 6 7 8).
	self assert: treeMorphOne1 ~= treeMorphOne2.

	self assert: (window submorphs last submorphs last submorphs first submorphs) isEmpty.
	
	((browser paneNamed: #one) port: #selection) value: 5.	
	treeMorphTwo2 := window submorphs last submorphs last submorphs first submorphs first.
	self assert: (treeMorphTwo2 model roots collect: #item) = #(50 51 52).
	self assert: treeMorphTwo1 ~= treeMorphTwo2! !

GLMMorphicTest subclass: #GLMMorphicExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMMorphicExamplesTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 23:01'!
testSmoke
	GLMBasicExamples allExamples do: [:eachPragma | 
		| input browser |
		input := Compiler evaluate: (eachPragma argumentAt: 2) logged: false.
		browser := GLMBasicExamples new perform: eachPragma selector.
		[window := browser openOn: input]
			ensure: [window notNil ifTrue: [window delete] ] ]! !

!GLMMorphicTest methodsFor: 'private' stamp: 'DamienCassou 5/11/2011 19:39'!
find: aClass in: aMorph
	"Explores aMorph hierarchy of sub morphs to find a morph whose class is aClass"
	aMorph allMorphsDo: [:each | (each class = aClass) ifTrue: [^ each]].
	^ nil ! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/17/2009 07:39'!
repeatAssert: aBlock equals: aResult

	self assert: (self wait: 0.5 until: aBlock evaluatesTo: aResult)! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 12/29/2009 00:42'!
send: treeMorph doubleClickWithShift: aBoolean onItem: treeNodeMorph
	| event |
	event:= MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph doubleClick: event! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 12/29/2009 00:39'!
send: treeMorph mouseDownWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onMorph: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/19/2009 11:39'!
send: treeMorph mouseUpOnItem: treeNodeMorph
	^ self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/29/2009 02:38'!
send: treeMorph mouseUpWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseUp
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onMorph: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'setup - tear down' stamp: 'tg 1/9/2010 22:12'!
tearDown
	window ifNotNil: [window delete]! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 1/6/2010 00:36'!
wait: maxWaitSeconds until: validateBlock evaluatesTo: expectedResult
	"Evaluate validateBlock until it returns expectedResult or 
maxWaitSeconds have passed,
	 pausing between evaluations.  Return the last result of validateBlock 
value"

	| startTime result |
	startTime := Time millisecondClockValue // 1000.
	[result := validateBlock value = expectedResult] whileFalse:
			[Time secondClock - startTime > maxWaitSeconds ifTrue: [^result].
			(Delay forMilliseconds: 50) wait].
	^ result
! !

GLMMorphicTest subclass: #GLMTableMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTableMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:41'!
testColumnBlockTakesEntity

	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser table
		column: 'Even' evaluated: [:each :entity | receivedEntity := entity. 'x'].
	window := browser openOn: (1 to: 5).
	World doOneCycle.
	self repeatAssert: [receivedEntity] equals: (1 to: 5).
! !

!GLMTableMorphicTest methodsFor: 'tests' stamp: 'tg 4/20/2010 16:34'!
testColumnLabel
	| browser  tableMorphOne tableMorphTwo |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a | 
		a table 
			display: [:x | (x - 3 to: x) ];
			column: 'Column' evaluated: [:x | x asString]].
	browser transmit to: #two; from: #one; andShow: [:a |
		a table 
			display: [:x | x * 10 to: (x * 10 + 2)];
			column: [:x | 'Number ', x asString] evaluated: #asString].
	window := browser openOn: 4.

	tableMorphOne := window submorphs last submorphs second submorphs first submorphs first.
	self assert: (tableMorphOne model roots collect: #item) = #(1 2 3 4).
	self assert: (tableMorphOne columns first header label = 'Column' ).
	((browser paneNamed: #one) port: #selection) value: 2.
	tableMorphTwo := window submorphs last submorphs last submorphs first submorphs first.
	self assert: (tableMorphTwo model roots collect: #item) = #(20 21 22).
	self assert: (tableMorphTwo columns first header label = 'Number 2' ).! !

GLMMorphicTest subclass: #GLMTabulatorMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTabulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:39'!
testMultipleInitialSelection
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			beMultiple;
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list ].
	window := browser openOn: 5.
	(browser panes first port: #selection) value: #(2 5 3).
	firstTreeMorph := window submorphs last submorphs second submorphs first submorphs first.
	secondTreeMorph := window submorphs last submorphs last submorphs first submorphs first.
	self assert: firstTreeMorph model selection notNil.
	self assert: firstTreeMorph model selection selectedItemOrItemsOrNil size = 3.
	self assert: secondTreeMorph model selection isNil.
	self assert: (secondTreeMorph model roots collect: #item) asSet = firstTreeMorph model selection selectedItemOrItemsOrNil asSet! !

!GLMTabulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:38'!
testSpawnTabulator

	| browser |
	browser := GLMTabulator new.
	window := browser openOn: ($a to: $d).
	self assert: window model == browser.
	self repeatAssert: [
		window submorphs last 
					submorphs last 
						submorphs last 
							submorphs last class] equals: LazyMorphTreeMorph.
! !

!GLMTabulatorMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:39'!
testStatusbar
	| browser statusMorph |
	browser := GLMTabulator new.
	browser addStatusbar.
	browser row: #one.
	browser transmit to: #one; andShow: [:a | a list display: #(1 2 3)].
	window := browser openOn: 42.
	((browser paneNamed: #one) port: #status) value: 2.
	World doOneCycle.
	statusMorph := (window submorphs last: 2) first submorphs first.	
	self assert: (statusMorph isKindOf: LabelMorph).

"	detailsMorph := window submorphs last submorphs last submorphs first.
"! !

GLMMorphicTest subclass: #GLMTextMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/5/2011 23:12'!
testForSmalltalk
	| browser textMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | a text forSmalltalk; display: '123456789'].
	window := browser openOn: 4.

	textMorph := window submorphs last submorphs first submorphs first.
	self assert: (textMorph isKindOf: GLMPluggableShoutMorph)! !

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'tg 1/26/2010 11:45'!
testMultipleSelectionWithChange
	| browser textMorph textPresentation |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | a text display: '123456789'].
	window := browser openOn: 4.

	textMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	self assert: textMorph selection isEmpty.
	textPresentation := (browser paneNamed: #one) presentations first.
	textPresentation selectionInterval: (2 to: 5).
	self assert: textMorph selection asString = '2345'! !

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/16/2011 22:15'!
testUnregisterFromAnnouncementsWhenUpdating
	| browser announcingCollection numberOfExecutions |
	numberOfExecutions := 0.
	announcingCollection := GLMAnnouncingCollection new.
	browser := GLMTabulator new.
	browser column: #text.
	browser transmit to: #text; andShow: [:a |
		a text 
			updateOn: GLMItemAdded from: [announcingCollection];
			display: [ numberOfExecutions := numberOfExecutions + 1]].
	window := browser openOn: announcingCollection.
	1 to: 3 do: [:each | announcingCollection add: each.].
	self assert: numberOfExecutions  = 4 "it should not be 8"! !

GLMMorphicTest subclass: #GLMTreeMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 22:00'!
testChildrenBlock
	| browser check |
	browser := GLMFinder new.
	check := false.
	browser tree
		children: [ :each | 
			check := true.
			#() ].
	window := browser openOn: ($a to: $d).
	World doOneCycle.
	self repeatAssert: [ check ] equals: true! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:39'!
testChildrenBlockTakesEntity
	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser tree
		children: [:each :entity | receivedEntity := entity. #()].
	window := browser openOn: ($a to: $d).
	World doOneCycle.
	self repeatAssert: [receivedEntity] equals: ($a to: $d).
! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:40'!
testTreeAllowDeseletion
	| browser treeNodeMorph |	
	browser := GLMFinder new.
	browser list allowDeselection.
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:39'!
testTreeDefaultAllowDeseletion
	| browser treeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value = $a.! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:41'!
testTreeMultipleSelection
	| browser treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple.
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	lastTreeNodeMorph := self treeRoots last.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (browser panes first port: #selection) value notNil.
	self assert: (browser panes first port: #selection) value asSet equals: ($a to: $d) asSet! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:43'!
testTreeMultipleSelectionWithCancellation
	| browser treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple allowDeselection.
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	lastTreeNodeMorph := self treeRoots last.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:43'!
testTreeSelection
	| browser treeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value = $a! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:48'!
testTreeSelectionCancellation
	| browser treeNodeMorph |
	browser := GLMFinder new.
	browser tree allowDeselection.
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:38'!
testTreeWithDisplay
	| browser treeCollection |
	treeCollection := { #root1->{#child1->{} . #child2->{}} . #root2 ->{} }.
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			display: [:each | each value ];
			children: [:x | x value ] ].
	window := browser openOn: #something -> treeCollection.
	self assert: browser panes first presentations first displayValue == treeCollection! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: 'DamienCassou 5/11/2011 20:15'!
testTreeWithTags
	"Creates a tree and tag some nodes. Then click on a tag and see if the unmatched nodes disappear"

	| browser model oddNode lineWithNumber3 someNode secondSome |
	model := Dictionary new.
	model at: #some put: #(1 2 3 4).
	model at: #even put: #(2 6 8).
	model at: #odd put: #(3 7 9).
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					(browser tree)
						display: [ model keys ];
						children: [ :key | 
									key isNumber
										ifFalse: [ model at: key ] ];
						tags: [ :item | 
									item isNumber
										ifTrue: [ 
											item even
												ifTrue: [ #('even') ]
												ifFalse: [ #('odd') ] ]
										ifFalse: [ #() ] ] ].
	window := browser openOn: model.
	World doOneCycle.
	oddNode := self treeRoots second.	
	
	oddNode toggleExpandedState. "Simulate a click on the node's arrow to expand the node and make sub nodes visible"

	World doOneCycle.
	lineWithNumber3 := self treeRoots third.
	(self find: SimpleButtonMorph in: lineWithNumber3) doButtonAction. "Simulate a click on the 'odd' tag to make even numbers disappear"
	
	World doOneCycle.
	someNode := self treeRoots first.
	someNode toggleExpandedState.
	World doOneCycle.
	secondSome := self find: TextMorph in: self treeRoots third.
	self assert: secondSome text asString equals: '3'! !

!GLMTreeMorphicTest methodsFor: 'private' stamp: 'DamienCassou 5/11/2011 20:17'!
tree
	^ self find: LazyMorphTreeMorph in: window! !

!GLMTreeMorphicTest methodsFor: 'private' stamp: 'DamienCassou 5/11/2011 20:48'!
treeRoots
	"Returns the roots of the tree included in the current window. It looks like morphic creates new collections when the tree is refreshed which means different calls to this method may return different objects."
	^ self tree scroller submorphs! !

GLMMorphicTest subclass: #GLMUpdateMorphicTest
	instanceVariableNames: 'announcer entity browser treeMorph listMorph tableMorph listLabelMorph unupdatedListMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/24/2011 22:33'!
expectedFailures
	^ #(testUpdatePresentationTitle)! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 14:45'!
setUp
	announcer := Announcer new.
	entity := OrderedCollection with: 1 with: 2 with: 3.
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a 
"			title: [:x | x printString ];"
			verticallyStackedArrangement.
		a list 
			title: [:x | x printString ];
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a tree 
			title: [:x | x printString ];
			children: #();
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a table
			title: [:x | x printString ];
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a text 
			updateOn: TestAnnouncement from: [ announcer ].
		a list 
			title: 'Not updated automatically';
			shouldValidate: true.
			 ].
	browser showOn: #two; from: #one; using: [browser text].
	window := browser openOn: entity.
	listLabelMorph := window submorphs last submorphs second submorphs first submorphs first tabSelectorMorph submorphs first submorphs first.
	listMorph := window submorphs last submorphs second submorphs first submorphs first submorphs first submorphs first submorphs first.
	treeMorph := window submorphs last submorphs second submorphs first submorphs second submorphs first submorphs first submorphs first.
	tableMorph := window submorphs last submorphs second submorphs first submorphs third submorphs first submorphs first submorphs first.
	unupdatedListMorph := window submorphs last submorphs second submorphs first submorphs last submorphs first submorphs first submorphs first.! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'tg 2/22/2010 13:35'!
testAdd
	entity add: 4.
	announcer announce: TestAnnouncement.
	self assert: listMorph model roots size = 4.
	self assert: treeMorph model roots size = 4.
	self assert: tableMorph model roots size = 4.
! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 14:46'!
testAddAndUpdateBrowserManually
	entity add: 4.
	self assert: unupdatedListMorph model roots size = 3.
	browser update.
	self assert: unupdatedListMorph model roots size = 4.
	entity add: 5.
	browser panes first presentations update.
	self assert: unupdatedListMorph model roots size = 5.! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:43'!
testAllowNil
	| browser detailsMorph |
	browser := GLMTabulator new.
	browser 
		column: [: c | c row: #one; row: #two];
		column: #details.
	browser showOn: #one; using: [
		browser tree display: #(1 2 3)].
	browser showOn: #two; using: [
		browser tree display: #(a b c)].
	browser showOn: #details; from: #one; from: #two; using: [
		browser text 
			display: [ :one :two | one asString, two asString];
			allowNil ].
	window := browser openOn: 42.
	((browser paneNamed: #one) port: #selection) value: 2.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = '2nil'.
	((browser paneNamed: #two) port: #selection) value: #c.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = '2c'.
	((browser paneNamed: #one) port: #selection) value: nil.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = 'nilc'.
! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 14:43'!
testAnnouncerUnregistration
	| subscription |
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 4.
	browser entity: #($a $b).
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 4.
	browser entity: #($d).
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 4.
	browser entity: #().
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 4.
	browser unregisterFromAllAnnouncements.
	subscription := announcer instVarNamed: 'subscriptions'.
	self deny: (subscription includesKey: TestAnnouncement).
	self assert: (announcer instVarNamed: 'subscriptions') isEmpty! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:43'!
testInterdependentPanesShouldUpdateTheFocusTriggerPane
	|browser treeMorphThree treeMorphThree2 |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three"; column: #four".
	browser transmit to: #one; andShow: [:a | a list display: [:x | 1 to: x]].
	browser transmit to: #two; from: #one; andShow: [:a | a list display: [:x | 1 to: x*2]].
	browser transmit to: #three; from: #two; andShow: [ :a |
		a list 
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
"	browser showOn: #four; from: #three; using: [browser text allowNil]."
	browser transmit to: #outer->#focus; from: #three->#focus.
	browser transmit to: #one->#selection; from: #outer->#focus; transformed: [:x | x + 1].
	browser transmit to: #two->#selection; from: #outer->#focus; transformed: [:x | x + 2].
	window := browser openOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.

	treeMorphThree := (window submorphs last submorphs at: 5) submorphs first submorphs first.

	((browser paneNamed: #three) port: #selection) value: 2.
	((browser paneNamed: #three) port: #focus) value: 1.

	self assert: ((browser paneNamed: #one) port: #entity) value = 5.
	self assert: ((browser paneNamed: #one) port: #selection) value = 2.
	self assert: ((browser paneNamed: #two) port: #entity) value = 2.
	self assert: ((browser paneNamed: #two) port: #selection) value = 3.
	self assert: ((browser paneNamed: #three) port: #entity) value = 3.
	self assert: ((browser paneNamed: #three) port: #selection) value isNil.

	treeMorphThree2 := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	self assert: treeMorphThree ~= treeMorphThree2! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/8/2011 22:43'!
testInterdependentPanesShouldUpdateTheFocusTriggerPaneWithText
	|browser treeMorphThree treeMorphThree2 |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three"; column: #four".
	browser transmit to: #one; andShow: [:a | a text display: [:x | 1 to: x]].
	browser transmit to: #two; from: #one; andShow: [:a | a text display: [:x | 1 to: x*2]].
	browser transmit to: #three; from: #two; andShow: [ :a |
		a text 
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
"	browser showOn: #four; from: #three; using: [browser text allowNil]."
	browser transmit to: #outer->#focus; from: #three->#focus.
	browser transmit to: #one->#selection; from: #outer->#focus; transformed: [:x | x + 1].
	browser transmit to: #two->#selection; from: #outer->#focus; transformed: [:x | x + 2].
	window := browser openOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.

	treeMorphThree := (window submorphs last submorphs at: 5) submorphs first submorphs first.

	((browser paneNamed: #three) port: #selection) value: 2.
	((browser paneNamed: #three) port: #focus) value: 1.

	self assert: ((browser paneNamed: #one) port: #entity) value = 5.
	self assert: ((browser paneNamed: #one) port: #selection) value = 2.
	self assert: ((browser paneNamed: #two) port: #entity) value = 2.
	self assert: ((browser paneNamed: #two) port: #selection) value = 3.
	self assert: ((browser paneNamed: #three) port: #entity) value = 3.
	self assert: ((browser paneNamed: #three) port: #selection) value isNil.

	treeMorphThree2 := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	self assert: treeMorphThree ~= treeMorphThree2! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'tg 2/28/2010 21:32'!
testInvalidateSelection
	(browser panes first port: #selection) value: 3.
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: (browser panes first port: #selection) value isNil.
	self assert: listMorph model selection isNil! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'tg 2/22/2010 13:39'!
testRemove
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: listMorph model roots size = 2.
	self assert: treeMorph model roots size = 2.
	self assert: tableMorph model roots size = 2.! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'tg 8/24/2010 22:06'!
testUpdateBrowserTitle

	browser title: 'something'.
	browser update.
	self assert: window label = 'something'! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 11:21'!
testUpdatePresentationTitle

	browser panes first presentations first title: 'something'.
	browser panes first presentations first update.
	self assert: listLabelMorph contents = 'something'! !

GLMMorphicTest subclass: #GLMWizardMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMWizardMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 4/12/2011 13:47'!
testClose
	| wizard |
	wizard := GLMWizard new.
	(wizard genericStep: #step) show: [:a | a text ] ; size: 2.
	window := wizard openOn: 123.
	self assert: window owner notNil.
	wizard close.
	self assert: window owner isNil! !

TestCase subclass: #LazyTabGroupTest
	instanceVariableNames: 'window tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!LazyTabGroupTest methodsFor: 'setup - tear down' stamp: 'TudorGirba 1/22/2011 22:30'!
setUp
	tabs := LazyTabGroupMorph new.
	tabs addLazyPage: (PanelMorph new fillStyle: (SolidFillStyle color: Color red)) label: 'one'.
	tabs addLazyPage: (PanelMorph new fillStyle: (SolidFillStyle color: Color yellow)) label: (LabelMorph contents: 'two').
	window := tabs openInWindow.
! !

!LazyTabGroupTest methodsFor: 'setup - tear down' stamp: 'TudorGirba 1/22/2011 22:22'!
tearDown
	window ifNotNil: [window delete]! !

!LazyTabGroupTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 22:30'!
testIsRendered
	self assert: tabs pages first isRendered not.
	tabs selectedPageIndex: 1.
	self assert: tabs pages first isRendered.
	self assert: tabs pages second isRendered not! !

!LazyTabGroupTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 23:36'!
testPageChangedAnnouncement
	| announcement page |
	announcement := 0.
	tabs announcer when: LazyTabPageChanged do: [:ann | 
		announcement := announcement + 1.
		page := ann page].
	tabs selectedPageIndex: 1.
	self assert: announcement = 1.
	self assert: (page isKindOf: LazyTabPage)! !

!LazyTabGroupTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 23:15'!
testPageRemovedAnnouncement
	| announcement |
	announcement := 0.
	tabs announcer when: LazyTabPageRemoved do: [:ann | announcement := announcement + 1].
	tabs removePage: tabs pages first.
	self assert: announcement = 1! !

!LazyTabGroupTest methodsFor: 'tests' stamp: 'TudorGirba 1/23/2011 00:34'!
testRemoveAllPages
	tabs removePage: tabs pages first.
	tabs removePage: tabs pages first.
	self assert: tabs pages isEmpty.
	self assert: tabs contentMorph submorphs isEmpty! !

!LazyTabGroupTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 22:33'!
testRemovePage
	tabs removePage: tabs pages first.
	self assert: tabs pages size = 1! !

!LazyTabGroupTest methodsFor: 'tests' stamp: 'TudorGirba 1/22/2011 22:30'!
testSimpleCreation
	self assert: tabs pages size = 2.! !
